Bug in openvpn user athentication



  • Edit:
    I found the error and fixed it by changing line 98 from $modeid = "server1" to  $modeid = "server1";

    Summary: missing ';' when generating /var/etc/openvpn/server??.php file

    –---------------------------------------------------------------------------------------------------------
    Snapshot: pfSense-2.0-BETA4-20101127-0230.iso.gz

    
    OpenVPN log: Nov 29 14:24:19 	openvpn[12008]: 172.21.64.234:54126 WARNING: Failed running command (--auth-user-pass-verify): external program exited with error status: 255
    
    

    running the auth command from the command line produces:

    /var/etc/openvpn/server1.php via-env
    Parse error: syntax error, unexpected T_IF in /var/etc/openvpn/server1.php on line 100
    

    Full server1.php file:

    
    #!/usr/local/bin/php -f
    /* $Id$ */
    /*
        openvpn.auth-user.php
    
        Copyright (C) 2008 Shrew Soft Inc
        Copyright (C) 2010 Ermal Luçi
        All rights reserved.
    
        Redistribution and use in source and binary forms, with or without
        modification, are permitted provided that the following conditions are met:
    
        1\. Redistributions of source code must retain the above copyright notice,
           this list of conditions and the following disclaimer.
    
        2\. Redistributions in binary form must reproduce the above copyright
           notice, this list of conditions and the following disclaimer in the
           documentation and/or other materials provided with the distribution.
    
        THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
        INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
        AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
        AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
        OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
        SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
        INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
        CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
        ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
        POSSIBILITY OF SUCH DAMAGE.
    
            DISABLE_PHP_LINT_CHECKING
    */
    /*
            pfSense_BUILDER_BINARIES:
            pfSense_MODULE: openvpn
    */
    /*
     * OpenVPN calls this script to authenticate a user
     * based on a username and password. We lookup these
     * in our config.xml file and check the credentials.
     */
    
    require_once("globals.inc");
    require_once("config.inc");
    require_once("radius.inc");
    require_once("auth.inc");
    require_once("interfaces.inc");
    
    /**
     * Get the NAS-Identifier
     *
     * We will use our local hostname to make up the nas_id
     */
    if (!function_exists("getNasID")) {
    function getNasID()
    {
        global $g;
    
        $nasId = "";
        exec("/bin/hostname", $nasId);
        if(!$nasId[0])
            $nasId[0] = "{$g['product_name']}";
        return $nasId[0];
    }
    }
    
    /**
     * Get the NAS-IP-Address based on the current wan address
     *
     * Use functions in interfaces.inc to find this out
     *
     */
    if (!function_exists("getNasIP")) {
    function getNasIP()
    {
        $nasIp = get_interface_ip();
        if(!$nasIp)
            $nasIp = "0.0.0.0";
        return $nasIp;
    }
    }
    /* setup syslog logging */
    openlog("openvpn", LOG_ODELAY, LOG_AUTH);
    
    /* read data from environment */
    $username = getenv("username");
    $password = getenv("password");
    $common_name = getenv("common_name");
    
    if (!$username || !$password) {
            syslog(LOG_ERR, "invalid user authentication environment");
            exit(-1);
    }
    
    /* Replaced by a sed with propper variables used below(ldap parameters). */
    $authmodes=array("Local Database");
     $modeid = "server1"
    
    if (file_exists("{$g['varetc_path']}/openvpn/{$modeid}.ca")) {
            putenv("LDAPTLS_CACERT={$g['varetc_path']}/openvpn/{$modeid}.ca");
            putenv("LDAPTLS_REQCERT=never");
    }
    
    $authenticated = false;
    
    if (($strictusercn === true) && ($common_name != $username)) {
            syslog(LOG_WARNING, "Username does not match certificate common name ({$username} != {$common_name}), access denied.\n");
            exit(1);
    }
    
    foreach ($authmodes as $authmode) {
            $authcfg = auth_get_authserver($authmode);
            if (!$authcfg && $authmode != "local")
                    continue;
    
            $authenticated = authenticate_user($username, $password, $authcfg);
            if ($authenticated == true)
                    break;
    }
    
    if ($authenticated == false) {
            syslog(LOG_WARNING, "user {$username} could not authenticate.\n");
            exit(-1);
    }
    
    syslog(LOG_WARNING, "user {$username} authenticated\n");
    
    exit(0);
    
    ?>
    
    

    (Running OpenVPN without user authentication works fine)



  • It was fixed just shortly before.
    Try a new snapshot or follow the ticket http://redmine.pfsense.org/issues/1037



  • Thanks for the info, but i can't any newer build on the snapshot server: http://snapshots.pfsense.org/FreeBSD_RELENG_8_1/i386/pfSense_HEAD/livecd_installer/?C=M;O=D (pfSense-2.0-BETA4-20101127-0230.iso.gz still the newest)

    (I downloaded it about 1-2 hours before reporting the bug)

    Though PFsense itself finds a update but when trying to invoke the auto-updater it stops with the following error: This image is not digitally signed. Update cannot continue

    Nevermind, i found the option to bypass signing verification
    –------------

    Not resolved after updating, ';' is still missing from line 98

    And there are no more updates for pfsense to install:
    Downloading new version information...done
    Obtaining current version information...done
    You are on the latest version.


  • Rebel Alliance Developer Netgate

    I checked in a fix for this, it works now. Either wait for a new snap, gitsync, or merge in the change to your openvpn.inc file manually. It's a simple fix.


Log in to reply